#include <windows.h>
#include "wrapi.h"

static HMODULE hWRAPI = 0;

BOOL LoadWRAPI(void)
{

#ifdef WIN32
	hWRAPI = LoadLibrary("wrapi32.dll");
#else
	hWRAPI = LoadLibrary("wrapi.dll");
#endif

	if ((int)hWRAPI < 32) return FALSE;

	(FARPROC)OpenRadioDevice = GetProcAddress(hWRAPI, "OpenRadioDevice");
	(FARPROC)CloseRadioDevice = GetProcAddress(hWRAPI, "CloseRadioDevice");

	(FARPROC)GetRadioDeviceInfo = GetProcAddress(hWRAPI, "GetRadioDeviceInfo");
	(FARPROC)GetSignalStrength = GetProcAddress(hWRAPI, "GetSignalStrength");
	
	// "Set" API functions
	(FARPROC)SetFrequency = GetProcAddress(hWRAPI, "SetFrequency");
	(FARPROC)SetMode = GetProcAddress(hWRAPI, "SetMode");
	(FARPROC)SetAtten = GetProcAddress(hWRAPI, "SetAtten");
	(FARPROC)SetMute = GetProcAddress(hWRAPI, "SetMute");
	(FARPROC)SetPower = GetProcAddress(hWRAPI, "SetPower");
	(FARPROC)SetVolume= GetProcAddress(hWRAPI, "SetVolume");
	(FARPROC)SetBFOOffset = GetProcAddress(hWRAPI, "SetBFOOffset");
	
	// "Get" API functions
	(FARPROC)GetFrequency = GetProcAddress(hWRAPI, "GetFrequency");
	(FARPROC)GetMode = GetProcAddress(hWRAPI, "GetMode");
	(FARPROC)GetAtten = GetProcAddress(hWRAPI, "GetAtten");
	(FARPROC)GetMute = GetProcAddress(hWRAPI, "GetMute");
	(FARPROC)GetPower = GetProcAddress(hWRAPI, "GetPower");
	(FARPROC)GetVolume= GetProcAddress(hWRAPI, "GetVolume");
	(FARPROC)GetBFOOffset = GetProcAddress(hWRAPI, "GetBFOOffset");

#ifdef WIN32
#ifdef UNICODE
	(FARPROC)GetModeString = GetProcAddress(hWRAPI, "GetModeStringW");
#else
	(FARPROC)GetModeString = GetProcAddress(hWRAPI, "GetModeStringA");
#endif
#else
	(FARPROC)GetModeString = GetProcAddress(hWRAPI, "GetModeString");
#endif


	return TRUE;
}